#include <windows.h>            // Standard Windows include for system defines
#include <stdlib.h>             // Standard library include
#include <winbase.h>            // Has WIN32 Comm library and structure DEFS
#include <stdio.h>              // I/O include for printf() function
#include <conio.h>              // Include for the getch() function
#include "comchk.h"
#include "rs232_dll.h"

void more_(void)
{
	printf("[^[L[Ǝɐi]\n"); getchar();
}

int main (void)
{
	unsigned char c,buf[80]; 
	int i,n,myport,BaudNum,PortNum;
	
	printf("Test terminal for FT232 by Kako \n");
	
	port_device_scan();
	port_device_pickup_by_type(2); // FTDI
	//port_device_pickup_by_type(3); // SiLabs CP210x,etc
	//port_device_pickup_by_type(4); // Prolific PL230x,etc
	//port_device_pickup_by_type(5); // Cyress EZ-USB HID-COM
	n = get_how_many_port_devices();
	if (n==0) {
		printf("FTDIfoCX܂\n"); more_();
		exit(1);
	} else {
		PortNum = get_port_number(0); // port# of 1st device
	}
	//BaudNum = 9600; // 9600 bps
	BaudNum = 921600; // 921600 bps
	
	printf("Port=COM%d , Baud=%d\n",PortNum,BaudNum);
	myport=PortNum;
	i=rs_open(myport,BaudNum);
	if (i==-1) {
		printf("COM%d|[g݂ȂAɎgpł\n",myport); more_();
		exit(1);
	}
	
	while (1) {
		if (rs_size(myport)) {
			c=rs_getch(myport);
			if ( (c<8)||((c>13)&&(c<32)) ) {
				continue;
			} else {
				if (c==0x0d) { printf("\n"); continue; }
				printf("%c",c); fflush(stdout); continue;
			}
		}
		if (kbhit()) {
			i=0;
			while (1) {
				c=getch();
				if (c==0x08) { i--; printf("%c %c",8,8); continue; }
				buf[i++]=c;	printf("%c",c); fflush(stdout);
				if (c==0x0d) { buf[i-1]='\0'; putchar(0x0a); break; }
			}
			rs_puts(myport,buf); rs_putch(myport,0x0d);
		}
	}
    return 0;
}
